#include <features.h>
#include <stddef.h>
#include <elf.h>
/*#include <bits/ldt.h>*/
#include "libc.h"
#include <pthread_impl.h>
#include <bits/ldt.h>
#include <string.h>

#define START "_start"

#include "crt_arch.h"

int main();
weak void _init();
weak void _fini();
int __libc_start_main(int (*)(), int, char **,
	void (*)(), void(*)(), void(*)());
void _start();

uint8_t _random[16] = {
    155, 28, 109, 173, 31, 72, 207, 244, 40, 197, 56, 40, 25, 248, 141, 71
};

extern void *_file_end;
extern void *_mem_end;
Elf64_Phdr _phdr = {
    PT_PHDR,
    PF_W | PF_X | PF_R,
    0,
    0x200000,
    0x0,
    (uint64_t) &_file_end,
    (uint64_t) &_mem_end,
    0x200000
};

uintptr_t _postargv[] = {
    0x0, /* envp */

    /* auxv */
    AT_NOTELF,   1,
    AT_BASE,     0x200000,
    AT_ENTRY,    (uintptr_t) _start,
    AT_CLKTCK,   100,
    AT_EGID,     1000,
    AT_EXECFN,   (uintptr_t) "(cross9)",
    AT_GID,      1000,
    AT_HWCAP,    0,
    AT_PAGESZ,   0x1000,
    AT_PHDR,     (uintptr_t) &_phdr,
    AT_PHENT,    sizeof(_phdr),
    AT_PHNUM,    1,
    AT_PLATFORM, (uintptr_t) "plan9",
    AT_SECURE,   0,
    AT_UID,      1000,
    AT_RANDOM,   (uintptr_t) _random,
    AT_NULL,     0x0,
};

void *_tls;
void **_tid_addr;
void *_brk;
int *_tid;
uint64_t *_fs;
struct user_desc *_thread_area;
extern void *_mem_end;

extern void *_tls_end, *_tls_start;

static struct builtin_tls {
	char c;
	struct pthread pt;
	void *space[16];
} builtin_tls[1];
#define MIN_TLS_ALIGN offsetof(struct builtin_tls, pt)

char **_argv;

void _start_c(void *sp)
{
    void *tid_addr;
	uint64_t fs;
	int tid;
	struct user_desc thread_area[3];

	int argc = *(int *) sp;
	sp += 8;
	char **argv = __builtin_alloca(argc * sizeof(char **) + sizeof(_postargv));

	memcpy(argv, sp, argc*8);
	memcpy(argv + argc, _postargv, sizeof(_postargv));

	_tls = __builtin_alloca(2*sizeof(void *) +
			sizeof(struct pthread) +
			(_tls_end - _tls_start) +
			MIN_TLS_ALIGN +
			+ MIN_TLS_ALIGN-1 & -MIN_TLS_ALIGN);

	_thread_area = thread_area;
    _tid_addr = &tid_addr;
	_brk = &_mem_end;
	_tid = &tid;
	_fs = &fs;

    __libc_start_main(main, argc, argv, _init, _fini, 0);
}
