#include <_9syscall.h>
#include <_9.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static int tid = -1;
static int pid = -1;
static int ppid = -1;

pid_t _9gettid(void)
{
	int ret;
	char buf[64];

	if (tid != -1) return tid;

	int fd = _9open("/dev/pid", O_RDONLY, 0);
	ret = _9read(fd, buf, 64);
	if (ret < 0) return -1;
	buf[ret] = 0;
	_9close(fd);
	return tid = atoi(buf);
}

pid_t _9getpid(void)
{
	int ret;
	char buf[64];

	if (pid != -1) return pid;

	snprintf(buf, 64, "/proc/%d/noteid", _9gettid());
	int fd = _9open(buf, O_RDWR, 0);
	ret = _9read(fd, buf, 64);
	if (ret < 0) return -1;
	buf[ret] = 0;
	_9close(fd);
	return pid = atoi(buf);
}

pid_t _9getppid(void)
{	int ret;
	char buf[64];

	if (ppid != -1) return ppid;

	int fd = _9open("/dev/ppid", O_RDONLY, 0);
	ret = _9read(fd, buf, 64);
	if (ret < 0) return -1;
	buf[ret] = 0;
	_9close(fd);
	return atoi(buf);

	snprintf(buf, 64, "/proc/%d/noteid", _9gettid());
	fd = _9open(buf, O_RDWR, 0);
	ret = _9read(fd, buf, 64);
	if (ret < 0) return -1;
	buf[ret] = 0;
	_9close(fd);
	return ppid = atoi(buf);
}
