#ifndef _LOCK_H
#define _LOCK_H
#define TRYACQUIRE(x) _9syscall_2(SYS_SEMACQUIRE, (uvlong) &(x), 0)
#define ACQUIRE(x) _9syscall_2(SYS_SEMACQUIRE, (uvlong) &(x), 1)
#define RELEASE(x) _9syscall_2(SYS_SEMRELEASE, (uvlong) &(x), 1)
#define ACQUIRED(x) (x == 0)
#define LOCKED 0
#define UNLOCKED 1
#endif
