#include <bits/ldt.h>
#include <errno.h>
#include <pthread.h>
#include <_9.h>

extern struct user_desc *_thread_area;
int _9set_thread_area(struct user_desc *u_info)
{
	static int ctr;
	if (u_info->entry_number == -1) u_info->entry_number = ctr++;
	if (u_info->entry_number > 3) return -EINVAL;
	_thread_area[u_info->entry_number] = *u_info;
	return 0;
}

extern uint64_t *_fs;
int _9arch_prctl(int code, unsigned long *addr)
{
	if (code != 0x1002 /* ARCH_SET_FS */ ) UNIMPLEMENTED;

	*_fs = (unsigned long) addr;
	return 0;
}

extern void **_tid_addr;
pid_t _9set_tid_address(int *tidptr)
{
	*_tid_addr = tidptr;
	return _9gettid();
}
